// ===================================================================
// $Id: $
//
// basrnd.cpp
//
//     Helper routines for random number generation
//
// REPLACEMENT_STRING
//
// Initial coding by Vlastimil Havran, 1999.

#include "configg.h"
#include "basrnd.h"
#include "errorg.h"

#ifdef __USE_MERSENNE_TWISTER
#include "mtwister.h"
#endif // __USE_MERSENNE_TWISTER

// ----------------------------------------------------------------

// Random generator used preferrably
//static
static MTRand MersenneTwister;

void
MersenneTwisterSetSeed(int newSeed)
{
//  MersenneTwisterSetSeed(newSeed);
  MersenneTwister.seed(newSeed);
}

double
MersenneTwisterRand()
{
  const float epsilon = 1e-6;

#if 1
  float value = MersenneTwister.randExc();
  if (value < 0.0) {
    value = 0.0;
    //FATAL << "MersenneTwister bad down" << endl;
  }
  if (value >= 1.0) {
    value = 1.0 - epsilon;
    //FATAL << "MersenneTwister bad up" << endl;
  }
  return value;
#else 
#if 1
  float value = MersenneTwister.Rand01d(0);
  if (value < 0.0) {
    value = 0.0;
    FATAL << "MersenneTwister bad down" << endl;
  }
  if (value >= 1.0 - epsilon) {
    value = 1.0 - epsilon;
    FATAL << "MersenneTwister bad up" << endl;
  }
  return value;
#else
  // the dimension is ignored,
  // generate random value in range [0;1f)
  return MersenneTwister.Rand01d(0);
#endif
#endif
}
