#ifndef _MATUSIK_H__
#define _MATUSIK_H__

#include "configh.h"
#include "brdfmodel.h"

#include <cstring>
#include <string.h>

// ------------------------------------------------------------------------
// Implementation of using the uncompressed data from Matusik model
class BRDF_Matusik: public BRDF
{
  // Matusik data
  double* brdfMatusik;
  char *filename;
  char basename[200];
public:
  BRDF_Matusik(const char *filenameV);
  virtual ~BRDF_Matusik();

  virtual int getID() const { return EE_Matusik;}
  virtual void getString(string &outstr) const;

  // returns cosine corrected value of BRDF given the illumination
  // and viewer angle in RGB, returns false on success
  virtual bool getBRDFValue(int irow, int jcol, // texture position
			    float theta_view, float phi_view, // viewer direction in radians
			    float theta_il, float phi_il, // illumination direction in radians
			    float RGB[]) const; // corresponding color
};

#endif // _MATUSIK_H__
